﻿;Packer example
UseZipPacker()     ; Doesn't handle characters such as 'æ', 'ø', 'å', but extracts correctly
UseBriefLZPacker() ; Characters are stored properly and extracts currectly
UseTARPacker()     ; Doesn't work with example below
UseLZMAPacker()    ; Doesn't work with example below


Structure _Relative
  full.s
  rel.s
EndStructure
Global NewList re._Relative()

Global Index.i
Global ExtractPathZip.s = GetPathPart(ProgramFilename()) + "UNPACKED_1\"
Global ExtractPathLZ.s  = GetPathPart(ProgramFilename()) + "UNPACKED_2\"
Global startpath.s = GetPathPart(ProgramFilename()) +"ToBePacked\"
index = FindString(startpath, "ToBePacked")

Declare.i ExamineDir(Path.s)
Declare.i ExtractEverything(ZipArchive.s)
Declare.s Slash(st.s)


Procedure.s Slash(st.s)
  If Right(st,1) <> "\" 
    ProcedureReturn st + "\"
  Else
    ProcedureReturn st
  EndIf
EndProcedure

Procedure.i ExamineDir(Path.s)
  Protected dir.i, Filename.s
  dir = ExamineDirectory(#PB_Any, Path, "*") 
  If dir > 0
    While NextDirectoryEntry(dir) 
      Filename = DirectoryEntryName(dir) 
      If DirectoryEntryType(dir) = #PB_DirectoryEntry_Directory And Filename <> "." And Filename <> ".." 
        ExamineDir(Slash(Path) + Filename)
      ElseIf DirectoryEntryType(dir) = #PB_DirectoryEntry_File And Filename <> "." And Filename <> ".."
        AddElement(re())
        re()\full = Slash(Path) + Filename
        re()\rel  = Mid(re()\full, index)
      EndIf 
    Wend 
    FinishDirectory(dir) 
  EndIf 
  ProcedureReturn ListSize(re())
EndProcedure


OpenWindow(0, 0, 0, 800, 600, "Packer", #PB_Window_SystemMenu|#PB_Window_ScreenCentered)
ListViewGadget(0, 0, 20, 400, 250)
GadgetToolTip(0, "These are files to be zip packed")
ListViewGadget(1, 402, 20, 396, 250)
GadgetToolTip(1, "This is zip pack archive listing after creation")
ListViewGadget(2, 0, 271, 400, 250)
GadgetToolTip(2, "These are files to be BriefLZ packed")
ListViewGadget(3, 402, 271, 396, 250)
GadgetToolTip(3, "This is BriefLZ archive listing")

;Create
If ExamineDir(GetPathPart(ProgramFilename()) + "ToBePacked") > 0
  pck.i = CreatePack(#PB_Any, "ThisIsPacked.zip", #PB_PackerPlugin_Zip)
  ForEach re()
    AddGadgetItem(0, -1, re()\full)
    AddPackFile(pck, re()\full, re()\rel)
  Next
  ClosePack(pck)
  
  pck.i = CreatePack(#PB_Any, "ThisIsPacked.blz", #PB_PackerPlugin_BriefLZ)
  ForEach re()
    AddGadgetItem(2, -1, re()\full)
    AddPackFile(pck, re()\full, re()\rel)
  Next
  ClosePack(pck)
;Examine

  pck = OpenPack(#PB_Any, "ThisIsPacked.zip", #PB_PackerPlugin_Zip)
  If pck > 0
    If ExaminePack(pck)
      While NextPackEntry(pck)
        AddGadgetItem(1, -1, PackEntryName(pck))
      Wend
    EndIf
    ClosePack(pck)
  EndIf
  

  pck = OpenPack(#PB_Any, "ThisIsPacked.blz", #PB_PackerPlugin_BriefLZ)
  If pck > 0
    If ExaminePack(pck)
      While NextPackEntry(pck)
        AddGadgetItem(3, -1, PackEntryName(pck))
      Wend
    EndIf
    ClosePack(pck)
  EndIf
  
EndIf

;Unpack

pck = OpenPack(#PB_Any,  "ThisIsPacked.zip", #PB_PackerPlugin_Zip)
If pck > 0
  If ExaminePack(pck)
    While NextPackEntry(pck)
      CreateDirectory(ExtractPathZip + GetPathPart(PackEntryName(pck)))
      If UncompressPackFile(pck, ExtractPathZip + PackEntryName(pck), PackEntryName(pck)) > -1
        Debug "ZIP: " + PackEntryName(pck) + " extraction succeeded"
      Else
        Debug "ZIP: " + PackEntryName(pck) + " Failed..."
      EndIf
    Wend
  EndIf
  ClosePack(pck)
EndIf

pck = OpenPack(#PB_Any, "ThisIsPacked.blz", #PB_PackerPlugin_BriefLZ)
If pck > 0
  If ExaminePack(pck)
    While NextPackEntry(pck)
      CreateDirectory(ExtractPathLZ + GetPathPart(PackEntryName(pck)))
      If UncompressPackFile(pck, ExtractPathLZ + PackEntryName(pck), PackEntryName(pck)) > -1
        Debug PackEntryName(pck) + " extraction succeeded"
      Else
        Debug PackEntryName(pck) + " Failed..."
      EndIf
    Wend
  EndIf
  ClosePack(pck)
EndIf

Repeat
  
  ev = WindowEvent()
  
Until ev = #PB_Event_CloseWindow


; IDE Options = PureBasic 5.60 (Windows - x64)
; CursorPosition = 64
; Folding = -
; EnableXP
; CompileSourceDirectory